module Structured
  class Boolean
    extend Structured::Type

    def self.parse(yaml_value, stack:, context: nil)
      unless yaml_value == true || yaml_value == false
        raise Structured::Errors::InvalidValue.new(
          stack,
          "#{stack} expects a boolean, but found: #{yaml_value.inspect}"
        )
      end
      yaml_value
    end
  end
end
