module Structured
  class Integer
    extend Structured::Type

    def self.parse(yaml_value, stack:, context: nil)
      unless yaml_value.is_a?(::Integer)
        raise Structured::Errors::InvalidValue.new(
          stack,
          "#{stack} expects an integer, but found: #{yaml_value.inspect}"
        )
      end
      yaml_value
    end
  end
end
