module Structured
  class Nullable
    def self.[](type)
      new(type)
    end

    def initialize(type)
      @type = type
    end

    def default_value
      nil
    end

    def parse(yaml_value, stack:, context: nil)
      return yaml_value if yaml_value.nil?
      @type.parse(yaml_value, stack: stack, context: context)
    end

    def type_name
      "Nullable[#{@type.type_name}]"
    end
  end
end
