module Structured
  class String
    extend Structured::Type

    def self.parse(yaml_value, stack:, context: nil)
      unless yaml_value.is_a?(::String)
        raise Structured::Errors::InvalidValue.new(
          stack,
          "#{stack} expects a string, but found: #{yaml_value.inspect}"
        )
      end
      yaml_value
    end
  end
end
